#!/usr/bin/env python3
# -*- coding: utf-8 -*-

#    Ce script permet à la coopérative Le Nid modifier le fichier de commande 
#    du fournisseur Biopartner, à partir de l'export d'un bon de commande dans Odoo.
#    Copyright (C) 2020  Marco de Freitas
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <https://www.gnu.org/licenses/>.
# 
#    contact: marco@sillage.ch

import os
import csv
import itertools
import re

import xlrd
from openpyxl import Workbook, load_workbook

extern_ref=re.compile('\[(\d+)\]')



NOM = 0 # identifiant interne du bulletin de commande ex:PO00180
DATE = 1
NOM_PRODUIT = 2
EAN = 3
NB = 4

def setup():
    if os.path.exists('Output/Gesamtes Sortiment.xlsx'):
                      os.remove('Output/Gesamtes Sortiment.xlsx')


def format_ref(string):
    delta = len(string)
    if delta > 0:
        string.zfill(delta)
    return string


def catch_ext_ref(string):
    match=extern_ref.match(string)
    if match is None:
        return string
    else:
        ref = format_ref(match.group(1))
        return ref
            




def read_order(file):
    with open(file, newline='') as csvfile:
        spamreader = csv.reader(csvfile, dialect='excel', delimiter=',', quotechar='"')
        metareader, datareader = itertools.tee(spamreader,2)
        metadata = [[row[NOM],row[DATE]] for row in metareader][1] # métadonnées sont dans les deux première colonnes, deuxième ligne uniquement
        order_id = metadata[0] # copie la valeur de l'ID de la commande 
        order_date = metadata[1] # copie la valeur de la date de la commande 
        order_date = order_date.split()[0] # formate la valeur, enlève heures:min:secondes
        order_lines = { (catch_ext_ref(row[NOM_PRODUIT])) : [ row[NOM_PRODUIT], row[EAN], row[NB] ] for row in datareader } # les lignes de commandes sont dans les colonnes 2, 3 , 4
        return order_lines, (order_id, order_date)

def read_biopartner(file):
    sheet = xlrd.open_workbook(file).sheet_by_index(0)
    with open("T.csv",'w',newline="") as temp_file:
        temp = csv.writer(temp_file, delimiter=',',quotechar='"',quoting=csv.QUOTE_MINIMAL)

        for row in range(sheet.nrows): 
            temp.writerow(sheet.row_values(row))

    with open("T.csv",'r',newline="") as temp_file:
        spamreader = csv.reader(temp_file, dialect='excel', delimiter=',', quotechar='"')

        ref_dict = {}

        for i, row in enumerate(spamreader):
##            if i == 148:
##                print(row[6])
            ref_dict[(row[6])]=i+1
    return ref_dict

def match_order_product(product_dictionnary, order_dictionnary):
    workbook=load_workbook('Input/Gesamtes Sortiment.xlsx')
    sheet = workbook.active
    rebus=[]
    for key in order_dictionnary.keys():
##        if key.isdigit():
            try:
##                sheet["H" + str(product_dictionnary[key])] = order_dictionnary[key][2]
                print("H" + str(product_dictionnary[key]) + ":" + order_dictionnary[key][2] +" " + order_dictionnary[key][0])
            except:
                print("Product",  key, type(key), " Not found")
##    workbook.save('Output/Gesamtes Sortiment.xlsx')
            

        
    
    
   
    


def write_output(file, data):
    wb=load_workbook('Input/Gesamtes Sortiment.xlsx')


if __name__ == "__main__":
    setup()
    order_lines_dictionnary, meta = read_order('Input/purchase.order.csv')
    product_lines_dictionnary = read_biopartner('Input/Gesamtes Sortiment.xlsx')
    match_order_product(product_lines_dictionnary,order_lines_dictionnary)


##
##ref=wb2['Sheet 1']['B2'].value
##date=wb2
##print(ref)



    
    
